Subject: Re: [tsvwg] A word for "does not have a significantly negative impact on traffic using standard congestion control"?

From: Bob Briscoe <[email-masked]>
Date: Thu, 6 May 2021 00:03:47 +0100

Follks,

Thank you to everyone who attempted to come up with terms.
I'm afraid none of the suggestions jumped out as what I was looking for 
- I merely wanted a brief proxy word for that long quote from RFC5033 in 
the subject line, no more, no less.

Then the conversation went off onto different questions, trying to 
define something beyond what RFC5033 said. I appreciate Sebastian's 
point that all this is unquantifiable, and I'm interested in taking that 
further. But for present purposes I didn't intend to be that ambitious - 
RFC5033 is good enough for now.

So, I'll just use the full phrase from RFC5033. It can still be replaced 
if someone comes up with something better.

FWIW, I did think of this:
     Unharmful,
as in 'unharmful to Reno'. Dictionaries define it as 'harmless', but 
it's sort-of guessable that it could involve more impact than harmless, 
but not so much as to be harmful.

Nonetheless, it's still not good enough to replace the whole phrase, 
IMO. Others may disagree.

Bob

On 10/03/2021 15:02, Sebastian Moeller wrote:
> Hi Bob,
>
> more below inline, prefixed [SM].
>
>> On Mar 10, 2021, at 15:05, Bob Briscoe <[email-masked]> wrote:
>>
>> Sebasitan
>>
>> On 10/03/2021 08:27, Sebastian Moeller wrote:
>>> Dear All,
>>>
>>> while I appreciate the attempt to strive for better nomenclature, I think here it is best to stick to the existing terms. Sure add a paragraph that explicitly spells out what it exactly means, but do not muddy the water with slightly different terms. Also, be as accurate and descriptive as possible.
>>>
>>> The argument that there are more protocols than TCP is a rather weak one, becauseIMHO " TCP-friendly" really just conveys that all internet-wide congestion response should strive to not harm TCP (still being one of the major traffic types in the net). Also this needs a strict definition of harm, so that congestion responses can be tested against this requirements and simply judged friendly or non-friendly.
>>>
>>> Bob later hints at a similar thought with:
>>> "Something that's not as sensitive to single losses as Reno. Which means it could push Reno down (somewhat more than say Cubic in Reno mode would), but not "significantly"."
>>>
>>> But IMHO this is a slippery slope (the scare quotes around significantly indicate a non-objective assessment), so please define the amount of harm that is permissible. And also, if that boils down to "do not starve" add an explicit definition of starvation that can be used in a statistical test, the old "I know starvation when I see it" definition is clearly in the eye of the beholder and hence pretty useless for designing and testing CC algorithms against.
>>>
>>> With all that said, how about something along the lines of:
>>>
>>> New congestion control algorithms, will share the internet with existing CCs for the foreseeable future, and hence need to c o-exist peacefully with existing CCs. Given TCP's importance in the early internet(?) such behaviour has been called TCP-friendly, and boils down to that new CCs do not do more harm to existing CC-flows than such existing flows would do to each other. In addition to the "no more harm" principle new CCs should also avoid driving other TCP-friendly flows into starvation. In this context starvation means a reduction of a flows capacity share, below 1/8 (3 orders of magnitude) its equitable capacity share if no new-CC flows would be present.
>> [BB] (I assume you mean 'Reno' here, each time you say 'TCP'.)
> 	[SM] Yes and no, I argue more that to achieve acceptable levels of sharing all CC's depoyed in the internet need to be compatible towards each other such that none outcompetes the others. Sure, Reno was probably the single TCP variant that left most impression on how TCP-friendly behaviour looks like, but as you experienced, naming it Reno-friendly got immediate opposition, while keeping TCP-friendly would not have done the same (my hypothesis) by virtue of being established nomenclature.
>
>> Whatever, the question was looking for a word that describes more harm than none.
> 	[SM] IMHO we need more than a word, we need something that is empirically testable. "None" is easy: if we find no statistical significant* effect of the new CC on existing CC's as compared to the effect of the old CC on itself, we are done, "no significant change automatically means no harm". If we want something else then "none", let's make it explicit and define it by numbers. Once we agree to numbers the words should come easy, like "mild harm", or "some harm" (but without precise definitions these words alone are pretty useless).
>
> *) You still need to define your acceptable false positive and false negative rates...
>
>> We saw in the survey at the last Nov '20 ICCRG that Reno is becoming a small minority. I suspect this is because it's over-sensitive to noise that often isn't really congestion (accepting that it's hard for any CC to know what caused a loss).
> 	[SM] I am not proposing to "enshrine" Reno's behavior for eternity here, but rather the dominant "TCP's" behaviour. The point is, every new protocol needs to understand what CC reference it needs to be compatible with. The exact definition of the reference behaviour probably can be discussed and might be open to gentle evolution to keep in sync with what is actually deployed in the internet. But as I see it, this evolution needs to be slow and compliance needs to be easily testable, so we want as precise a definition of the desired behavior as we can agree on.
>
>> We're looking for a way to describe the congestion controls that do actually do some harm to such "over-sensitive" congestion controls, but not significant harm.
> 	[SM] Well, then lay out a) how much harm you deem acceptable (the list will haggle over the numbers, but in the end something verifiable needs to come out) and b) how to assess harm. This needs to be exquisitely clear, because otherwise it is doomed to abuse, no?
>
>
>>> IMHO that captures the gist of the issue:
>>> 1) do no harm: is a concise phrasing of "does not have a significantly negative impact"
>> [BB] That would be "do no significant harm", as explained above.
> 	[SM] That depends on how you interpret/use significant in that sentence.
>
>>> 2) giving a definition of clearly acceptable harm (what TCP-friendly CCs already inflict on each other).
>>> 3) tackles the so far under defined starvation issue heads on by giving a definition of starvation that can be empirically confirmed during tests
>>> 4) uses a reference rate for the starvation calculation that effortlessly allows for prioritization and selective shaping on each node where the sharing behaviour is explored.
>>> 5) by having a numerical definition of starvation and of the reference sharing behaviour, it becomes possible to statistically test whether the new CC significantly harms existing TCP-friendly traffic or not (getting rid of the subjective components of "significantly").
>> [BB] I'd like to work on this.
>>
>> I believe the problem is similar to relative poverty. It depends on some notion of average (long-running, capacity-seeking) flow rate in a deployment environment, not solely the other rates in one bottleneck.
> 	[SM] Mmmh, not sure I fully understand and/or agree. Congestion only materializes in bottlenecks (or conversely we simply call the location of congestion the bottleneck), so the relative sharing behaviour of different CCs should be assessed exactly at those bottlenecks. But I guess most likely, I did not get the gist of your last point.
>
> Best Regards
> 	Sebastian
> 	
>
>
>>
>> Bob
>>
>>> This blurb clearly is not perfect, but IMHO worth discussing.
>>>
>>>
>>> Best Regards
>>> 	Sebastian
>>>
>>>
>>>> On Mar 9, 2021, at 02:19, Bob Briscoe <[email-masked]> wrote:
>>>>
>>>> tsvwg-ers,
>>>>
>>>> In the survey of the L4S Prague Requirements, we got quite significant push-back from developers about our two requirements to fall back to Reno-Friendly (which the draft defines as a translation of 'TCP-Friendly' into transport-agnostic language, 'cos TCP isn't the only transport these days).
>>>>
>>>> Basically, people don't want to have to fall back to something as lame a Reno (apologies if that's disparaging, but I'm just the messenger).
>>>>
>>>> I was hoping people would interpret 'Reno-Friendly' liberally. But everyone takes Reno-Friendly to mean quite close to Reno behaviour - not surprising really, given the definition of TCP-Friendly in TFRC is roughly within 2x of Reno [RFC5348] (pasted at the end).
>>>>
>>>> What I'm looking for is a word that means "does not have a significantly negative impact on traffic using standard congestion control", which
>>>> RFC5033 allows for experimental congestion controls.
>>>>
>>>>
>>>>
>>>> ==Details from the RFCs==
>>>>
>>>> RFCRFC2914 (borrowing from RFC2309) defines TCP-compatible to mean the same behaviour as Reno (essentially).
>>>>
>>>> RFC5348 defines the term TCP-Friendly, which was originally intended for real-time media - to allow the rate to temporarily stray from TCP-compatible because it needed to remain more stable as available capacity varied. But it was also used for regular elastic congestion controls like Cubic. Here's the TFRC definition.
>>>>
>>>>     TFRC is designed to be reasonably fair when competing for bandwidth
>>>>     with TCP flows, where we call a flow "reasonably fair" if its sending
>>>>     rate is generally within a factor of two of the sending rate of a TCP
>>>>     flow under the same conditions.  However, TFRC has a much lower
>>>>     variation of throughput over time compared with TCP, which makes it
>>>>     more suitable for applications such as telephony or streaming media
>>>>     where a relatively smooth sending rate is of importance.
>>>>
>>>>
>>>> In RFC5033, Sally Floyd wrote this, which is a useful turn of phrase. I'd just like to find a shorter way of saying it:
>>>>
>>>>         Alternate congestion controllers that have a
>>>>         significantly negative impact on traffic using standard
>>>>         congestion control may be suspect
>>>>
>>>>
>>>>
>>>> Bob
>>>> -- 
>>>> ________________________________________________________________
>>>> Bob Briscoe
>>>> http://bobbriscoe.net/
>> -- 
>> ________________________________________________________________
>> Bob Briscoe                               http://bobbriscoe.net/

-- 
________________________________________________________________
Bob Briscoe                               http://bobbriscoe.net/